
//
// Oggetti per la gestione di preference della widget, default e configurazione
//
//
// Uso:
//
// var wPref = new WidgetPreference({
//
//		interval: 10,
//		display: 'random'
//	});
//

var WidgetPreference = Class.create();

WidgetPreference.prototype = {

  initialize: function(appName, appVersion, defaults) {

		this.mAppName = appName;
		this.mAppVersion = appVersion;
    this.defaults = {
      __serial:       ''
    }.extend(defaults || {});
    
    this.SetUniqueSerial();
  },
  
  Get: function(key) {

		if (window.widget) {
		
				var res = widget.preferenceForKey(this.BuildKey(key));
				return (res) ? res : this.defaults[key];

		} else
			return this.defaults[key];
	},

  Set: function(key, value) {

			// memorizza solo se diverso dal default
  
		if (value != this.defaults[key]) {
  
			if (window.widget)
					widget.setPreferenceForKey(value, this.BuildKey(key));
		}
	},

	BuildKey: function(key) {
  
			return this.mAppName + '_' + key;
	},

	SetUniqueSerial: function() {

			// lo crea solamente se non esiste
  
		if (this.Get('__serial') == '') {

			var d = new Date();
			var s = 'MS_' + d.getTime();
  
			this.Set('__serial', s);
		}
	},

	GetUniqueSerial: function() {

		return this.Get('__serial');
	}
}

//
// Gestione del versioning
//

function CheckForNewVersion(appName, curVersion, serial) {

	var pars = 'OP=V&AN=' + appName + '&CV=' + curVersion + '&S=' + serial;

// onComplete: QueryDone, 
	var request = new Ajax.Request('http://neo.furuz/cverond/version.php', {asynchronous: false, method: 'get', parameters: pars});

    if (request.transport.status == 200) {

			var newVersionData = request.transport.responseText;

			return newVersionData;

//    	alert('CheckForNewVersion(): Risultato: ' + request.transport.responseText);

			return (newVersionData != 'NONE');

//    	alert('CheckForNewVersion(): Risultato: ' + request.transport.responseText);

    } else {
    	alert('CheckForNewVersion(): Error in loading: ' + request.transport.status);
//    	for (v in transport)
//				alert(v + ': ' + transport[v]);
    }

//		return this.Get('__serial');
}
